function Create(self)
	self.PowerTimer = Timer()
	self.RotTimer = Timer()
	self.HealTimer = Timer()
	
	self.Shield = CreateActor("Shield", "ForceField.rte")
	self.Shield.Pos = self.Pos + Vector(0,-63)
	self.Shield.Team = self.Team
	self.Shield.Health = 33
	MovableMan:AddActor(self.Shield)
end

function Destroy(self)
	if MovableMan:ValidMO(self.Shield) and self.Shield.PresetName == "Shield" then
		self.Shield.ToDelete = true
	end
	
	if MovableMan:ValidMO(self.Glow) and self.Glow.PresetName == "Shield Glow" then
		self.Glow.ToDelete = true
	end
end

function Update(self)
	if self.Sharpness > 0 then
		if not self.Shield then
			if self.PowerTimer:IsPastSimMS(10000) then
				self.Shield = CreateActor("Shield", "ForceField.rte")
				self.Shield.Pos = self.Pos + Vector(0,-63)
				self.Shield.Team = self.Team
				self.Shield.Health = 33
				MovableMan:AddActor(self.Shield)
			end
		else
			if not MovableMan:ValidMO(self.Shield) or self.Shield.PresetName ~= "Shield" then
				self.Shield = nil
				self.PowerTimer:Reset()
				
				if self.Glow then
					if MovableMan:IsParticle(self.Glow) then
						self.Glow.ToDelete = true
					end
					
					self.Glow = nil
				end
			else
				if self.Shield.Health < 0 then
					self.Shield.ToDelete = true
					if MovableMan:ValidMO(self.Glow) and self.Glow.PresetName == "Shield Glow" then
						self.Glow.ToDelete = true
					end
				else
					if self.RotTimer:IsPastSimMS(125) then
						self.RotTimer:Reset()
						self:SetNextFrame()
					end
					
					if self.HealTimer:IsPastSimMS(450) then
						self.HealTimer:Reset()
						self.Shield.Health = math.min(self.Shield.Health+1, 100)
					end
					
					if not self.Glow or not MovableMan:IsParticle(self.Glow) or self.Glow.PresetName ~= "Shield Glow" then
						self.Glow = CreateMOSParticle("Shield Glow", "ForceField.rte")
						self.Glow.Pos = self.Shield.Pos
						MovableMan:AddParticle(self.Glow)
					else
						self.Glow.Pos = self.Shield.Pos
					end
				end
			end
		end
	else
		if self.Shield then
			if MovableMan:ValidMO(self.Shield) and self.Shield.PresetName == "Shield" then
				self.Shield.ToDelete = true
			end
			
			self.Shield = nil
		end
		
		if self.Glow then
			if MovableMan:IsParticle(self.Glow) and self.Glow.PresetName == "Shield Glow" then
				self.Glow.ToDelete = true
			end
			
			self.Glow = nil
		end
	end
end

function ForceFieldOn(self)
	self.Sharpness = 1
end

function ForceFieldOff(self)
	self.Sharpness = 0
end